(function() {
    tinymce.create('tinymce.plugins.wp_simple_geo', {
        /**
         * Initializes the plugin, this will be executed after the plugin has been created.
         * This call is done before the editor instance has finished it's initialization so use the onInit event
         * of the editor instance to intercept that event.
         *
         * @param {tinymce.Editor} ed Editor instance that the plugin is initialized in.
         * @param {string} url Absolute URL to where the plugin is located.
         */
        init : function(ed, url) {
            ed.addButton('wp_simple_geo',{
                title   : wp_simple_geo.title,
                cmd     : "wp_simple_geo",
                image   : wp_simple_geo.url + "/assets/images/globe.png"
            });

            ed.addCommand("wp_simple_geo",function(){
                var selected_text   = ed.selection.getContent({format:'html'});
                console.log("selected text : ",selected_text);
                var return_text     = "";
                jQuery(".wp_simple_geo_content").val(selected_text);
                tb_show(wp_simple_geo.title,"#TB_inline?height=540&amp;width=740&amp;inlineId=wp_simple_geo_holder&amp;modal=false",null)
            });
        },

        /**
         * Creates control instances based in the incomming name. This method is normally not
         * needed since the addButton method of the tinymce.Editor class is a more easy way of adding buttons
         * but you sometimes need to create more complex controls like listboxes, split buttons etc then this
         * method can be used to create those.
         *
         * @param {String} n Name of the control to create.
         * @param {tinymce.ControlManager} cm Control manager to use inorder to create new control.
         * @return {tinymce.ui.Control} New control instance or null if no control was created.
         */
        createControl : function(n, cm) {
            return null;
        },

        /**
         * Returns information about the plugin as a name/value array.
         * The current keys are longname, author, authorurl, infourl and version.
         *
         * @return {Object} Name/value array containing information about the plugin.
         */
        getInfo : function() {
            return {
                longname : 'WP Simple Geo',
                author  :  'Ridwan Arifandi',
                authorurl : 'http://ridwanarifandi.com',
                infourl : 'http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/example',
                version : "1"
            };
        }
    });

    // Register plugin
    tinymce.PluginManager.add( 'wp_simple_geo', tinymce.plugins.wp_simple_geo );

    jQuery(".wp_simple_geo p.submit input[type=button]").click(function(e){
        var input   = [];
        e.preventDefault();
        jQuery(".wp_simple_geo").find(".insta-field").each(function(index,element){
            var name    = jQuery(element).attr("name");
            var value   = jQuery(element).val();

            if(typeof name !== "undefined" && value != "" && value != null)
            {   input.push({
                    name:name,
                    value:value
                })
            }
        });

        jQuery.ajax({
            url     : ajaxurl,
            type    : "POST",
            dataType: "html",
            data    : {
                action  : "wp_simple_geo_shortcode",
                input   : input,
                text    : jQuery(".wp_simple_geo_content").val()
            },
            beforeSend  : function() {

            },
            success : function(response) {
                tinymce.execCommand('mceInsertContent', false, response);
                tb_remove();
            }
        })
    });
})();
